← All problems

2780. Minimum Index of a Valid Split

MediumOpen on LeetCodeProblem statement

Problem Statement

2780. Minimum Index of a Valid Split

Medium


An element x of an integer array arr of length m is dominant if more than half the elements of arr have a value of x.

You are given a 0-indexed integer array nums of length n with one dominant element.

You can split nums at an index i into two arrays nums[0, ..., i] and nums[i + 1, ..., n - 1], but the split is only valid if:

Here, nums[i, ..., j] denotes the subarray of nums starting at index i and ending at index j, both ends being inclusive. Particularly, if j < i then nums[i, ..., j] denotes an empty subarray.

Return the minimum index of a valid split. If no valid split exists, return -1.

 

Example 1:

Input: nums = [1,2,2,2]
Output: 2
Explanation: We can split the array at index 2 to obtain arrays [1,2,2] and [2]. 
In array [1,2,2], element 2 is dominant since it occurs twice in the array and 2 * 2 > 3. 
In array [2], element 2 is dominant since it occurs once in the array and 1 * 2 > 1.
Both [1,2,2] and [2] have the same dominant element as nums, so this is a valid split. 
It can be shown that index 2 is the minimum index of a valid split. 

Example 2:

Input: nums = [2,1,3,1,1,1,7,1,2,1]
Output: 4
Explanation: We can split the array at index 4 to obtain arrays [2,1,3,1,1] and [1,7,1,2,1].
In array [2,1,3,1,1], element 1 is dominant since it occurs thrice in the array and 3 * 2 > 5.
In array [1,7,1,2,1], element 1 is dominant since it occurs thrice in the array and 3 * 2 > 5.
Both [2,1,3,1,1] and [1,7,1,2,1] have the same dominant element as nums, so this is a valid split.
It can be shown that index 4 is the minimum index of a valid split.

Example 3:

Input: nums = [3,3,3,3,7,2,2]
Output: -1
Explanation: It can be shown that there is no valid split.

 

Constraints:

Java

Source file
class Solution {
    public int minimumIndex(List<Integer> nums) {
        // Find dominant element (mode)
        Map<Integer, Integer> freq = new HashMap<>();
        int n = nums.size(), maxCount = 0, mode = -1;
        for (int i : nums) {
            freq.put(i, freq.getOrDefault(i, 0) + 1);
            if (freq.get(i) > maxCount) {
                maxCount = freq.get(i);
                mode = i;
            }
        }
        // Compute dominant element counts prefix sum
        int prefixSum = 0;
        for (int i = 0; i < n; i++) {
            if (nums.get(i) == mode)
                prefixSum++;
            // System.out.println(i + 1 + "\t" + prefixSum);
            if ((i+1) / 2 < prefixSum && (n - 1 - i) / 2 < (maxCount - prefixSum))
                return i;
        }
        return -1;
    }
}